
/*
  Short test program to accompany fix_fft.c
*/

#define DEBUG 0
#define SPECTRUM 1

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <string.h>
#include <stdint.h>

#include "fix_fft.h"
//#include "siren_signals.h"

#define M_PI 3.14159265358979323846

float hamming_window(int n, int _N)
{
    return (0.54f - 0.46f * cosf(2*M_PI*n/(_N-1)));
}

int main()
{
	#define FFTSIZE 128
	int log2n = 7; //2^10 = 1024

	int i;
	const int fs = 16384;
	// 
	int fsine = 2048;
	double phase = 0;
	short fx[FFTSIZE * 2];
	short xx[FFTSIZE * 2];
	short tmp;
	short module[FFTSIZE];
	int scale;
	FILE* f;

	for(i = FFTSIZE; i < FFTSIZE*2; i++){
		fx[i] = 0;
		xx[i] = 0;
	}

	/*
	fx -      ,   
	*/

	for (i = 0; i < FFTSIZE; i++){
		xx[i] = (short) (5000 * cos(i * 2 * M_PI * fsine / fs + phase)  ); 
		xx[i] += (short) (1500 * cos(i * 2 * M_PI * fsine*2 / fs + phase) ); 
		//xx[i] = (fsound_siren[i+1] - 64/2) << 8;
		//fx[i] = xx[i] * hamming_window(i, FFTSIZE);
		fx[i] = xx[i];
	}

	scale = fix_fft(&fx[0], &fx[FFTSIZE], log2n, 0);
	printf("scale = %d\n", scale);
	
	for(i = 0; i < FFTSIZE; i++){
		module[i] = (short) sqrt((double)(fx[i] * fx[i] + fx[FFTSIZE+i] * fx[FFTSIZE+i]));
	}
	
	f = fopen("fft.txt", "w");
	for(i = 0; i < FFTSIZE / 2; i++){
		module[i] *= 2; //restore amplitude
		fprintf(f, "%d\t\t%d\n",  i * (fs / 2) / (FFTSIZE/2), module[i]);
		//fprintf(f, "%d\n", module[i]);
	}
	
	fclose(f);
	getch();
}

